/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.dataone.mock.tidy.dao;

import java.io.IOException;
import java.io.InputStream;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.dataone.cn.dao.exceptions.DataAccessException;
import org.dataone.service.types.v1.Identifier;
import org.dataone.service.types.v1.NodeReference;
import org.dataone.service.types.v1.SystemMetadata;
import static org.dataone.service.util.TypeMarshaller.unmarshalTypeFromStream;
import org.dataone.test.knb.data.KnbRecords;
import org.dataone.tidy.dao.SystemMetadataTidyDao;
import org.jibx.runtime.JiBXException;

/**
 *
 * @author waltz
 */
public class MockKnbSystemMetadataTidyDao implements SystemMetadataTidyDao {

    private static Log logger = LogFactory.getLog(MockKnbSystemMetadataTidyDao.class);

    @Override
    public List<Identifier> listIdentifiers() throws DataAccessException {
        List<Identifier> identifierList = new ArrayList<Identifier>();
        try {
            KnbRecords emlRecords = new KnbRecords();
            List<String> fileNames;

            fileNames = emlRecords.getFiles();

            for (String filename : fileNames) {
                Identifier identifier = new Identifier();
                identifier.setValue(filename);
                identifierList.add(identifier);
            }
        } catch (URISyntaxException ex) {
            logger.error(ex);
        } catch (IOException ex) {
            logger.error(ex);
        }
        return identifierList;
    }

    @Override
    public Map<NodeReference, SystemMetadata> getSystemMetadata(Identifier identifier) throws DataAccessException {
        Map<NodeReference,SystemMetadata> systeMetadataMap = new HashMap<NodeReference,SystemMetadata>();
        try {
            KnbRecords emlRecords = new KnbRecords();
            SystemMetadata systemMetadata = new SystemMetadata();
            
            NodeReference orcNodeReference = new NodeReference();
            orcNodeReference.setValue("urn:node:CNORC1");
            NodeReference unmNodeReference = new NodeReference();
            orcNodeReference.setValue("urn:node:CNUNM1");
            NodeReference ucsbNodeReference = new NodeReference();
            ucsbNodeReference.setValue("urn:node:CNUCSB1");
            
            InputStream in = emlRecords.getSystemMetadata(identifier.getValue());
            SystemMetadata orcSystemMetadata = unmarshalTypeFromStream(systemMetadata.getClass(), in);
            orcSystemMetadata.setOriginMemberNode(orcNodeReference);
            orcSystemMetadata.setAuthoritativeMemberNode(orcNodeReference);
            systeMetadataMap.put(orcNodeReference, orcSystemMetadata);
            
            in = emlRecords.getSystemMetadata(identifier.getValue());
            SystemMetadata unmSystemMetadata = unmarshalTypeFromStream(systemMetadata.getClass(), in);
            unmSystemMetadata.setOriginMemberNode(unmNodeReference);
            unmSystemMetadata.setAuthoritativeMemberNode(unmNodeReference);
            systeMetadataMap.put(unmNodeReference, unmSystemMetadata);
            
            in = emlRecords.getSystemMetadata(identifier.getValue());
            SystemMetadata ucsbSystemMetadata = unmarshalTypeFromStream(systemMetadata.getClass(), in);
            ucsbSystemMetadata.setOriginMemberNode(ucsbNodeReference);
            ucsbSystemMetadata.setAuthoritativeMemberNode(ucsbNodeReference);
            systeMetadataMap.put(ucsbNodeReference, ucsbSystemMetadata);
            
        } catch (IOException ex) {
            throw new DataAccessException(ex);
        } catch (InstantiationException ex) {
            throw new DataAccessException(ex);
        } catch (IllegalAccessException ex) {
            throw new DataAccessException(ex);
        } catch (JiBXException ex) {
            throw new DataAccessException(ex);
        }
         
        return systeMetadataMap;
    }

    @Override
    public void saveSystemMetadata(SystemMetadata systemMetadata) throws DataAccessException {
        logger.info("Saved " + systemMetadata.getIdentifier().getValue());
    }

}
