/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.dataone.mock.tidy.dao;

import java.io.IOException;
import java.io.InputStream;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.dataone.cn.dao.exceptions.DataAccessException;
import org.dataone.service.types.v1.Identifier;
import org.dataone.service.types.v1.NodeReference;
import org.dataone.service.types.v1.SystemMetadata;
import static org.dataone.service.util.TypeMarshaller.unmarshalTypeFromStream;
import org.dataone.test.knb.data.KnbRecords;
import org.dataone.tidy.dao.SystemMetadataTidyDao;
import org.jibx.runtime.JiBXException;

/**
 *
 * @author waltz
 */
public class MockSimpleSystemMetadataTidyDao implements SystemMetadataTidyDao {

    private static Log logger = LogFactory.getLog(MockSimpleSystemMetadataTidyDao.class);

    @Override
    public List<Identifier> listIdentifiers() throws DataAccessException {
        List<Identifier> identifierList = new ArrayList<Identifier>();
        Identifier id1 = new Identifier();
        id1.setValue("someid1");
        Identifier id2 = new Identifier();
        id2.setValue("someid2");
        identifierList.add(id1);
        identifierList.add(id2);
        return identifierList;
    }

    @Override
    public Map<NodeReference, SystemMetadata> getSystemMetadata(Identifier identifier) throws DataAccessException {
        Map<NodeReference, SystemMetadata> systeMetadataMap = new HashMap<NodeReference, SystemMetadata>();

        SystemMetadata systemMetadata = new SystemMetadata();

        NodeReference orcNodeReference = new NodeReference();
        orcNodeReference.setValue("urn:node:CNORC1");
        NodeReference unmNodeReference = new NodeReference();
        orcNodeReference.setValue("urn:node:CNUNM1");
        NodeReference ucsbNodeReference = new NodeReference();
        ucsbNodeReference.setValue("urn:node:CNUCSB1");

        systeMetadataMap.put(orcNodeReference, systemMetadata);

        systeMetadataMap.put(unmNodeReference, systemMetadata);

        systeMetadataMap.put(ucsbNodeReference, systemMetadata);

        return systeMetadataMap;
    }

    @Override
    public void saveSystemMetadata(SystemMetadata systemMetadata) throws DataAccessException {
        logger.info("Saved " + systemMetadata.getIdentifier().getValue());
    }

}
